/*
 * CompanyDataView.java
 *
 * Created on 10 de agosto de 2004, 18:09
 */

package com.fenalco.servlets.supplier;

import java.io.IOException;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.City;
import com.fenalco.entities.Company;
import com.fenalco.entities.DataAccess;
import com.fenalco.entities.Province;
import com.fenalco.entities.Supplier;
import com.fenalco.entities.User;
import com.fenalco.utilities.MessageBuilder;

/**
 * Este servlet genera la información necesaria para mostrar al usuario
 * proveedor la información de su empresa.
 * 
 * @author andres
 */
public class CompanyDataView extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 * 
	 * @param config
	 *            Parámetro de configuración
	 * @throws ServletException
	 *             Excepción de fallo en la operación de inicialización
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destruye el servlet.
	 */
	public void destroy( )
	{

	}

	/*
	 * Procesa las peticiones para los métodos HTTP <code> GET </code> y <code>
	 * POST </code> .
	 * 
	 * Identificador del proveedor --> session "user"
	 * 
	 * Para construir la información necesaria de la empresa se deben crear un
	 * objeto <CODE> Company </CODE> con el identificador del proveedor, también
	 * se debe crear un objeto <CODE> Supplier </CODE> para obtener información
	 * específica del proveedor.
	 * 
	 * Esta información es enviada a <CODE> datosempresa.jsp </CODE> para ser
	 * presentada al usuario @param request Petición al servlet @param response
	 * Respuesta del servlet @throws ServletException Excepción de fallo en la
	 * operación de procesamiento de peticiones @throws IOException Excepción de
	 * fallo de la operación de escritura con el flujo <CODE> PrintWriter
	 * </CODE> de response.
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		HttpSession session = request.getSession(false);
		RequestDispatcher dispatcher;

		String url = "/proveedor/datosempresa.jsp";
		String message = "";

		//Validación de sesión
	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 2 )
			{
	
				url = "/logout";
				//message = "Sesión no iniciada";
				message = MessageBuilder.buildMessage(15);
	
			}
			else
			{
	
				User supplierUser = (User) session.getAttribute("user");
				Company company = new Company(supplierUser.getCompanyId());
				Supplier supplier = new Supplier(supplierUser.getCompanyId());
	
				//System.out.println(company.getCityName());
				if( company == null || supplier == null )
				{
	
					//Fallo en la carga de datos de la empresa del proveedor
					url = "/proveedor/datosempresa.jsp";
					//message = "Error al cargar los datos de la empresa";
					message = MessageBuilder.buildMessage(6);
	
				}
				else
				{
					//Todo OK
					Vector countriesList = DataAccess.getValidCountries();
					Vector provincesList = null;
					Vector citiesList = null;
					Vector neighbourhoodsList = null;
	
					//int provinceId =
					// DataAccess.getCityProvince(company.getCityId());
					//int countryId = DataAccess.getProvinceCountry(provinceId);
					int provinceId = -1;
					int countryId = -1;
					int cityId = -1;
					int neighbourhoodId = 1;
					String combo = request.getParameter("combo");
					//System.out.println(combo);
	
					if( combo != null )
					{
	
						countryId = (new Integer(request.getParameter("country")))
								.intValue();
						//System.out.println(countryId);
						provinceId = (new Integer(request.getParameter("province")))
								.intValue();
						//System.out.println(provinceId);
						cityId = (new Integer(request.getParameter("city")))
								.intValue();
						//System.out.println(cityId);
						/*
						 * String temp = request.getParameter("neighbourhood");
						 * 
						 * if(temp != null){ neighbourhoodId = ( new Integer ( temp
						 * )).intValue(); }
						 */
	
						provincesList = DataAccess.getValidProvinces(countryId);
						citiesList = DataAccess.getCities(provinceId);
						//neighbourhoodsList =
						// DataAccess.getNeighbourhoods(cityId);
	
						if( combo.equals("country") )
						{
	
							Enumeration en = provincesList.elements();
							provinceId = ((Province) en.nextElement()).getId();
							citiesList = DataAccess.getCities(provinceId);
							en = citiesList.elements();
							cityId = ((City) en.nextElement()).getId();
							//neighbourhoodsList =
							// DataAccess.getNeighbourhoods(cityId);
	
						}
						else
							if( combo.equals("province") )
							{
								//citiesList = DataAccess.getCities( provinceId);
								Enumeration en = citiesList.elements();
								cityId = ((City) en.nextElement()).getId();
								//neighbourhoodsList =
								// DataAccess.getNeighbourhoods(cityId);
							}
					}
					else
					{
	
						provinceId = DataAccess
								.getCityProvince(company.getCityId());
						countryId = DataAccess.getProvinceCountry(provinceId);
						
	
						provincesList = DataAccess.getValidProvinces(countryId);
						Enumeration en = provincesList.elements();
						//provinceId = ((Province)en.nextElement()).getId();
						citiesList = DataAccess.getCities(provinceId);
						//en = citiesList.elements();
						//cityId = ((City)en.nextElement()).getId();
						cityId = company.getCityId();
						
						//neighbourhoodsList =
						// DataAccess.getNeighbourhoods(cityId);
					}
	
					Hashtable sectorList = DataAccess.getSectors();
					Hashtable ciiuList = DataAccess.getCiiu();
	
					request.setAttribute("countriesList", countriesList);
					request.setAttribute("provincesList", provincesList);
					request.setAttribute("citiesList", citiesList);
					request.setAttribute("sectorList", sectorList);
					request.setAttribute("ciiuList", ciiuList);
					////////////////////////////////////////////////////
					request.setAttribute("countryId", new Integer(countryId));
					request.setAttribute("provinceId", new Integer(provinceId));
					request.setAttribute("cityId", new Integer(cityId));
					///////////////////////////////////////////////////
					request.setAttribute("company", company);
					request.setAttribute("supplier", supplier);
	
					url = "/proveedor/datosempresa.jsp";
					//message = "Los datos de la empresa fueron cargados
					// correctamente";
					//message = MessageBuilder.buildMessage(3);
					message = "";
				}
	
			}
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }

		request.setAttribute("message", message);
		dispatcher = getServletContext().getRequestDispatcher(url);
		dispatcher.forward(request, response);
	}

	/**
	 * Maneja el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo de la operación de escritura con el flujo
	 *             <CODE>PrintWriter</CODE> de response.
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Maneja el método HTTP <code>POST</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo de la operación de escritura con el flujo
	 *             <CODE>PrintWriter</CODE> de response.
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Información general del servlet.
	 * 
	 * @return Retorna una descripción general del servlet
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}